



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[译]Python面试中8个必考问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[译]Python面试中8个必考问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 23:21:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1、下面这段代码的输出结果是什么？请解释。</p>
<pre class="prettyprint linenums"><code>def extendList(val, list=[]):<br />
	list.append(val)<br />
	return list

list1 = extendList(10)<br />
list2 = extendList(123,[])<br />
list3 = extendList('a')

print &quot;list1 = %s&quot; % list1<br />
print &quot;list2 = %s&quot; % list2<br />
print &quot;list3 = %s&quot; % list3<br />
</code></pre>
<p>怎样修改extendList的定义能够产生以下预期的行为?</p>
<p>上面代码输出结果将是：</p>
<pre class="prettyprint linenums"><code>list1 = [10, 'a']<br />
list2 = [123]<br />
list3 = [10, 'a']<br />
</code></pre>
<p>很多人都会误认为list1=[10],list3=['a'],因为他们以为每次extendList被调用时，列表参数的默认值都将被设置为[].但实际上的情况是，新的默认列表只在函数被定义的那一刻创建一次。当extendList被没有指定特定参数list调用时，这组list的值随后将被使用。这是因为带有默认参数的表达式在函数被定义的时候被计算，不是在调用的时候被计算。<br /><br />
因此list1和list3是在同一个默认列表上进行操作（计算）的。而list2是在一个分离的列表上进行操作（计算）的。（通过传递一个自有的空列表作为列表参数的数值）。</p>
<p>extendList的定义可以作如下修改。尽管，创建一个新的列表，没有特定的列表参数。</p>
<p>下面这段代码可能能够产生想要的结果。</p>
<pre class="prettyprint linenums"><code>def extendList(val, list=None):<br />
  if list is None:<br />
    list = []<br />
  list.append(val)<br />
  return list<br />
</code></pre>
<p>通过上面的修改，输出结果将变成：</p>
<pre class="prettyprint linenums"><code>list1 = [10]<br />
list2 = [123]<br />
list3 = ['a']<br />
</code></pre>
<p>2、下面这段代码的输出结果将是什么？请解释。</p>
<pre class="prettyprint linenums"><code>def multipliers():<br />
  return [lambda x : i * x for i in range(4)]

print [m(2) for m in multipliers()]<br />
</code></pre>
<p>你如何修改上面的multipliers的定义产生想要的结果？上面代码输出的结果是[6, 6, 6, 6] (不是我们想的[0, 2, 4, 6])。</p>
<p>上述问题产生的原因是Python闭包的延迟绑定。这意味着内部函数被调用时，参数的值在闭包内进行查找。<br /><br />
因此，当任何由multipliers()返回的函数被调用时，i的值将在附近的范围进行查找。<br /><br />
那时，不管返回的函数是否被调用，for循环已经完成，i被赋予了最终的值3。<br /><br />
因此，每次返回的函数乘以传递过来的值3，因为上段代码传过来的值是2，它们最终返回的都是6。(3*2)<br /><br />
碰巧的是，《The Hitchhiker’s Guide to Python》也指出，在与lambdas函数相关也有一个被广泛被误解的知识点，不过跟这个case不一样。由lambda表达式创造的函数没有什么特殊的地方，它其实是和def创造的函数式一样的。</p>
<p>下面是解决这一问题的一些方法。<br /><br />
一种解决方法就是用Python生成器。</p>
<pre class="prettyprint linenums"><code>def multipliers():<br />
  for i in range(4): yield lambda x : i * x<br />
</code></pre>
<p>另外一个解决方案就是创造一个闭包，利用默认函数立即绑定。</p>
<pre class="prettyprint linenums"><code>def multipliers():<br />
  return [lambda x, i=i : i * x for i in range(4)]<br />
</code></pre>
<p>还有种替代的方案是，使用偏函数：</p>
<pre class="prettyprint linenums"><code>from functools import partial<br />
from operator import mul

def multipliers():<br />
  return [partial(mul, i) for i in range(4)]<br />
</code></pre>
<p>3、下面这段代码的输出结果将是什么？请解释。</p>
<pre class="prettyprint linenums"><code>class Parent(object):<br />
	x = 1

class Child1(Parent):<br />
	pass

class Child2(Parent):<br />
	pass

print Parent.x, Child1.x, Child2.x<br />
Child1.x = 2<br />
print Parent.x, Child1.x, Child2.x<br />
Parent.x = 3<br />
print Parent.x, Child1.x, Child2.x<br />
</code></pre>
<p>输出结果将是：</p>
<pre class="prettyprint linenums"><code>1 1 1<br />
1 2 1<br />
3 2 3<br />
</code></pre>
<p>让很多人困惑或惊讶的是最后一行输出为什么是3 2 3 而不是 3 2 1.<br /><br />
为什么在改变parent.x的同时也改变了child2.x的值？但与此同时没有改变Child1.x的值？ 此答案的关键是，在Python中，类变量在内部是以字典的形式进行传递。</p>
<p>如果一个变量名没有在当前类下的字典中发现。<br /><br />
则在更高级的类（如它的父类）中尽心搜索直到引用的变量名被找到。（如果引用变量名在自身类和更高级类中没有找到，将会引发一个属性错误。）<br /><br />
因此,在父类中设定x = 1,让变量x类(带有值1)能够在其类和其子类中被引用到。这就是为什么第一个打印语句输出结果是1 1 1<br /><br />
因此，如果它的任何一个子类被覆写了值（例如说，当我们执行语句Child.x = 2）,这个值只在子类中进行了修改。这就是为什么第二个打印语句输出结果是1 2 1<br /><br />
最终，如果这个值在父类中进行了修改，（例如说，当我们执行语句Parent.x = 3）,这个改变将会影响那些还没有覆写子类的值（在这个例子中就是Child2）这就是为什么第三打印语句输出结果是3 2 3</p>
<p>4、下面这段代码在Python2下输出结果将是什么？请解释。</p>
<pre class="prettyprint linenums"><code>def div1(x,y):<br />
    print &quot;%s/%s = %s&quot; % (x, y, x/y)

def div2(x,y):<br />
    print &quot;%s//%s = %s&quot; % (x, y, x//y)

div1(5,2)<br />
div1(5.,2)<br />
div2(5,2)<br />
div2(5.,2.)<br />
</code></pre>
<p>在Python3下结果会有怎样的不同？（当然，假设上述打印语句被转换成Python3的语法）</p>
<p>在Python2中，上述代码输出将是</p>
<pre class="prettyprint linenums"><code>5/2 = 2<br />
5.0/2 = 2.5<br />
5//2 = 2<br />
5.0//2.0 = 2.0<br />
</code></pre>
<p>默认情况下，Python 2 自动执行整形计算如果两者都是整数。因此,5/2 结果是2，而5./2结果是2.5 注意，在Python2中，你可以通过增加以下引用来覆写这个行为。</p>
<p>from <strong>future</strong> import division<br /><br />
同时要注意的是，//操作符将总是执行整形除法，不管操作符的类型。这就是为什么即使在Python 2中5.0//2.0的结果是2.0。<br /><br />
然而在Python3中，没有此类特性，例如，在两端都是整形的情况下，它不会执行整形除法<br /><br />
因此，在Python3中，将会是如下结果：</p>
<pre class="prettyprint linenums"><code>5/2 = 2.5<br />
5.0/2 = 2.5<br />
5//2 = 2<br />
5.0//2.0 = 2.0<br />
</code></pre>
<p>5、下面代码的输出结果将是什么？</p>
<pre class="prettyprint linenums"><code>list = ['a', 'b', 'c', 'd', 'e']<br />
print list[10:]<br />
</code></pre>
<p>下面的代码将输出[],不会产生IndexError错误。 就像所期望的那样，尝试用超出成员的个数的index来获取某个列表的成员。<br /><br />
例如，尝试获取list[10]和之后的成员，会导致IndexError.<br /><br />
然而，尝试获取列表的切片，开始的index超过了成员个数不会产生IndexError,而是仅仅返回一个空列表。<br /><br />
这成为特别让人恶心的疑难杂症，因为运行的时候没有错误产生，导致bug很难被追踪到。</p>
<p>6、考虑下列代码片段：</p>
<pre class="prettyprint linenums"><code>1. list = [ [ ] ] * 5<br />
2. list  # output?<br />
3. list[0].append(10)<br />
4. list  # output?<br />
5. list[1].append(20)<br />
6. list  # output?<br />
7. list.append(30)<br />
8. list  # output?<br />
</code></pre>
<p>2,4,6,8行将输出什么结果？试解释。</p>
<p>输出的结果如下：</p>
<pre class="prettyprint linenums"><code>[[], [], [], [], []]<br />
[[10], [10], [10], [10], [10]]<br />
[[10, 20], [10, 20], [10, 20], [10, 20], [10, 20]]<br />
[[10, 20], [10, 20], [10, 20], [10, 20], [10, 20], 30]<br />
</code></pre>
<p>解释如下：<br /><br />
第一行的输出结果直觉上很容易理解，例如 list = [ [ ] ] * 5 就是简单的创造了5个空列表。<br /><br />
然而，理解表达式list=[ [ ] ] * 5的关键一点是它不是创造一个包含五个独立列表的列表，而是它是一个创建了包含对同一个列表五次引用的列表。<br /><br />
只有了解了这一点，我们才能更好的理解接下来的输出结果。</p>
<p>list[0].append(10) 将10附加在第一个列表上。</p>
<p>但由于所有5个列表是引用的同一个列表，所以这个结果将是：</p>
<pre class="prettyprint linenums"><code>[[10], [10], [10], [10], [10]]<br />
</code></pre>
<p>同理，list[1].append(20)将20附加在第二个列表上。但同样由于5个列表是引用的同一个列表，所以输出结果现在是：</p>
<pre class="prettyprint linenums"><code>`[[10, 20], [10, 20], [10, 20], [10, 20], [10, 20]].`<br />
</code></pre>
<p>作为对比， list.append(30)是将整个新的元素附加在外列表上，因此产生的结果是： <code>[[10, 20], [10, 20], [10, 20], [10, 20], [10, 20], 30].</code></p>
<p>7、Given a list of N numbers。<br /><br />
给定一个含有N个数字的列表。</p>
<p>使用单一的列表生成式来产生一个新的列表，该列表只包含满足以下条件的值：<br /><br />
(a)偶数值<br /><br />
(b)元素为原始列表中偶数切片。</p>
<p>例如，如果list[2]包含的值是偶数。<br /><br />
那么这个值应该被包含在新的列表当中，因为这个数字同时在原始列表的偶数序列（2为偶数）上。然而，如果list[3]包含一个偶数，</p>
<p>那个数字不应该被包含在新的列表当中，因为它在原始列表的奇数序列上。<br /><br />
对此问题的简单解决方法如下：</p>
<pre class="prettyprint linenums"><code>[x for x in list[::2] if x%2 == 0]<br />
</code></pre>
<p>例如，给定列表如下：</p>
<pre class="prettyprint linenums"><code>list = [ 1 , 3 , 5 , 8 , 10 , 13 , 18 , 36 , 78 ]<br />
</code></pre>
<p>列表生成式<code>[x for x in list[::2] if x%2 == 0]</code> 的结果是，</p>
<pre class="prettyprint linenums"><code>[10, 18, 78]<br />
</code></pre>
<p>这个表达式工作的步骤是，第一步取出偶数切片的数字，第二步剔除其中所有奇数。</p>
<p>给定以下字典的子类：</p>
<pre class="prettyprint linenums"><code>class DefaultDict(dict):<br />
  def __missing__(self, key):<br />
	return []<br />
</code></pre>
<p>8、下面的代码能够运行么？为什么？</p>
<pre class="prettyprint linenums"><code>d = DefaultDict()<br />
d['florp'] = 127<br />
</code></pre>
<p>能够运行。当key缺失时，执行DefaultDict类，字典的实例将自动实例化这个数列。</p>
<hr>
<p>原文链接：<a href="https://www.toptal.com/python/interview-questions" rel="external nofollow noreferrer">《8 Essential Python Interview Questions》</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qw7yw38.html">jq 拖拽</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xk4pw9.html">JQuery EasyUI内Combobox的onChange事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k16jm69.html">ActiveForm</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn4k56q.html">基于JAX-WS的Web Service服务端&sol;客户端 ；JAX-WS &plus; Spring 开发webservice</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwn3oq.html">JDK5-增强for循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp50r69.html">https post</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojgzl5q.html">winform &sol; Dev全局皮肤组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zowwxnq.html">各类聚类（clustering）算法初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwdjxz8.html">接口测试总结分享（http与rpc）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2ypno9.html">yield生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvr6n28.html">python学习之老男孩python全栈第九期&lowbar;day007作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/9633zrv9.html">R语言 ggplot2 画平滑图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8konv5jq.html">javaScript的内置对象以及一些常用的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp573l9.html">&lbrack;leetcode&rsqb;125&period; Valid Palindrome判断回文串</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp7p7d9.html">Centeros7下安装Mysql 2018最新版，非常简单</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pg6kr8.html">java IO流 对文件操作的代码集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2g4rd8.html">Python3&period;6（windows系统）安装pip&period;whl</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2mw6z8.html">IOS  NSBundle的使用，注意mainBundle和Custom Bundle的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/953616z8.html">Scheme 4 Javaer-3&period;高阶函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnjgz4q.html">AngularJS实现鼠标右键事件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/950nwn08.html">android 分享一个处理BaseAdapter，getView&lpar;&rpar;多次加载的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1ogedq.html">Bootstrap学习笔记（二）---常见工具和流程导航范例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zolevxq.html">JavaWeb之ssm框架整合，用户角色权限管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzxxde8.html">bash shell快捷键&lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j66y38.html">快速学习Bash</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjzzyy8.html">Intellij IDEA 像eclipse那样给maven添加依赖</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p44w38.html">scala-Future和Promise</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gexky78.html">BZOJ 4819 新生舞会</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kdoe49.html">Notepad&plus;&plus;使用教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mex426q.html">微信小程序&plus;&OpenCurlyDoubleQuote;芝麻小客服&rdquo;可设自动关注公众号，助力运营闭环</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
